#!/usr/bin/env python
from scapy.all import *
import subprocess

p = rdpcap("feel-it.pcap")

def main():
    set_report_request()

def set_report_request():
    global p

    for i in range(len(p)):
        data_fragments = ""
        pkt = p[i]

        if not pkt.haslayer(Raw):
            continue

        rawstr = str(pkt.getlayer(Raw))

        # Check host -> 1.9.0 SET_REPORT Request
        if rawstr[8] != '\x53' or rawstr[10] != '\x00' or rawstr[40] != '\x21':
            continue

        # Decode bytes in data fragment from bytes to dots
        for b in rawstr[64:len(rawstr)]:
            decode = byte_decode(ord(b))
            if decode != "":
                data_fragments += "p" + decode

        # Output dots to ASCII conversion thanks to bconv
        print str(i+1) + "| " + subprocess.check_output(['./bconv/bconv', '-f', 'd', '-t', 'a', data_fragments])
        
# Decodes a byte to dots
def byte_decode(b):
    dots = ""
    for i in range(8):
        if ((b >> i) & 0x1) == 1:
            dots += str(i+1)
    dots.strip()
    return dots    

# Encodes a byte from dots
def byte_encode(dots):
    b = 0
    dots = dots[1:]
    for c in dots:
        b |= (1 << (int(c) - 1))
    return "\\x{:02x}".format(b)

if __name__ == "__main__":
    main()
